#!/usr/bin/perl

use CGI qw(:standard :html3);
use DBI;
use strict;

my @months = ( 9905, 9906, 9907, 9908, 9909 );
my @netgroupnames;
my %id2name;

sub no2ip {
	my $no=$_[0];
	my $i;
	my $ipadr;
	my $j;
	for($i=0;$i<4;$i++) {
		$j=$no % 256;
		$ipadr=$j . "." . $ipadr;
		$no/=256;
	}
	chop($ipadr);
	return($ipadr);
}

sub showng {
	my ($ngid, $dbh, $month) = @_;
	my $j;
	my %totalbytes;

	my $sth = $dbh->prepare("select network.begin,network.end from network,netgroup where network.network_id = netgroup.network_id and netgroup.netgroup_id = ?");
	my $nqh = $dbh->prepare("select acct.ipaddress,netgroupnames.netgroup_name,acct.bytes/(1024*1024) from acct,netgroupnames where acct.netgroup_id = netgroupnames.netgroup_id and acct.month = ? and ipaddress between ? and ? order by ipaddress");

	# This causes perl to handle the string as an integer *oergs* 
	my $day = ($month . "01") * 1;

	$sth->execute($ngid);
	while(my @nwrow = $sth->fetchrow()) {
		print(h4("Network " . no2ip($nwrow[0]) . " - " . no2ip($nwrow[1])));
		$nqh->execute($day, $nwrow[0], $nwrow[1]);	
		print("<TABLE>\n");
		while(my ($ipnum, $ng, $bytes) = $nqh->fetchrow()) {

			$totalbytes{$ng}+=$bytes;
				
			if ($j ne $ipnum) {
				printf("<TR><TD width=20%>%s<TD width=60%>%s<TD width=20% align=right>%7.1f MB\n",
					no2ip($ipnum), $ng, $bytes);
				$j=$ipnum;
			} else {
				printf("<TR><TD width=20%><TD width=60%>%s<TD width=20% align=right>%7.1f MB\n",
					$ng, $bytes);
			}
		}
		print("</TABLE>\n");
	}

	print(h4("Total per destination netgroup"));
	print("<TABLE>\n");
	my $ng;
	foreach $ng ( keys %totalbytes ) {
		print("<TR><TD>$ng<TD align=right>$totalbytes{$ng} MB\n");
	}
	print("</TABLE>\n");
}

print		header(),
		start_html(-title=>"Accounting",
		-bgcolor=>"#ffffffff",
		-text=>"Text");

my $dbh = DBI->connect("DBI:mysql:database=ipacct:host=localhost:user=flo:password=P\@u5e") or die "failed open";
my $sth = $dbh->prepare("select netgroupnames.netgroup_name,netgroupnames.netgroup_id from netgroupnames");

$sth->execute();
while(my @row = $sth->fetchrow()) {
	push @netgroupnames, $row[0];
	$id2name{$row[0]}=$row[1];
}

if (param('month') eq '' &&
	param('netgroup') eq '') {
	print hr,
		start_form,
		"Month:",popup_menu(-name=>'month', -values=>\@months, -default=>$months[$#months]),
		"Netgroup:",popup_menu(-name=>'netgroup', -values=>\@netgroupnames),
		submit(-label=>'Send query').
		hr;
} else {
	if (!defined($id2name{param('netgroup')})) {
		print h1("Ops - undefined netgroup\n");
	} else {
		print h2("Listing netgroup " . param('netgroup') . " for " . param('month')),hr;
		my $ngid=$id2name{param('netgroup')};

		showng($ngid, $dbh, param('month'));
	}
}
print end_html;
