
#include "config.h"

#include <stdio.h>

#include "loaddata.h"

inline struct ipan_struct *match_ipan(unsigned long ip1, struct ipan_struct *network) {
	while(network->begin != 0 ||
			network->end != 0) {

			if (ip1 >= network->begin &&
					ip1 <= network->end)
					return(network);

			network++;
	}
	return(0);
}

int add_source(unsigned long ip1, unsigned long ip2, struct iparoot_struct *root, DATA_TYPE bytes) { 
	struct ipan_struct	*src,
						*dst;
	unsigned long		offset;
	while(root->no_address != 0) {
		/* Does source match ? */
		if ((src=match_ipan(ip1,root->source))) {
				if (!(dst=match_ipan(ip2,root->destination))) {
						fprintf(stderr, "ops: source matched - dst not %lu %lu %Lu\n",
										ip1,ip2,bytes);
				} else {
					offset=src->value+(ip1-src->begin)+dst->value;
#ifdef DEBUG
					printf("\t&root = %p\n",root);
					printf("\troot->no_address = %lu\n",root->no_address);
					printf("\troot->no_netgroup = %lu\n",root->no_netgroup);
					printf("\toffset = %lu\n",offset);
					printf("\tip1 = %s\n",num2ip(ip1));
					printf("\tsrc->begin = %s\n",num2ip(src->begin));
					printf("\tsrc->end = %s\n",num2ip(src->end));
					printf("\tsrc->value = %lu\n",src->value);
					printf("\t&src = %p\n",src);
					printf("\t&root->source = %p\n", root->source);
					printf("\tip2 = %s\n",num2ip(ip2));
					printf("\tdst->begin = %s\n",num2ip(dst->begin));
					printf("\tdst->end = %s\n",num2ip(dst->end));
					printf("\tdst->value = %lu\n",dst->value);
					printf("\t&dst = %p\n",dst);
					printf("\t&root->destination = %p\n", root->destination);

					printf("\n");
#endif
					root->data[offset]+=bytes; 
					return(1);
				}
		}
		root++;
	}	
	return(0);
}

void add_root(unsigned long ip1, unsigned long ip2, DATA_TYPE bytes, struct iparoot_struct *root) {
	int calc=0;
	calc+=add_source(ip1,ip2,root,bytes);
	calc+=add_source(ip2,ip1,root,bytes);
	/* Could we account this pair to ANY destination ? */
	if (calc == 0) {
		/* Split up into 2 fprintf -> num2ip uses static buffer */
		fprintf(stderr,"not accountable %15s ",
					num2ip(ip1));
		fprintf(stderr,"%15s %Lu\n",num2ip(ip2),bytes);
	}
}
